<?php


// mysql connection


// prerequisites
require_once ('config/config.php');
require_once ('functions/log.php');
require_once ('functions/params.php');


function mysql_die() {
	// terminates program, calling my die function to print out log and mysql error
	global $mysql;
	my_die ('mysql error: ' . $mysql->error);
}


function connect_mysql() {
	// connect to database
	global $mysql, $mysql_param;
	app_log ('connecting to mysql');
	extract ($mysql_param);
	@$mysql = new mysqli ($server, $username, $password, $database);
	if ($mysql->connect_error) {
		my_die ('connect error (' . $mysql->connect_errno . ') ' . $mysql->connect_error);
	}
}


function check_table() {
	// look for table and create if necessary
	global $mysql, $table;
	$table = check_param ('table', '[^[:alnum:]]');
	if (empty ($table)) {
		my_die ('no table specified');
	}
	app_log ('create table ' . $table . ' if necessary');
	$mysql->query ('
		create table if not exists ' . $table . ' (
			timestamp datetime not null,
			value decimal(10,2) not null,
			diff decimal(10,2),
			unique (timestamp) 
		)'
	) or mysql_die();
}


function delete_table() {
	// delete table
	global $mysql, $table;
	app_log ('delete table ' . $table);
	$mysql->query ('drop table ' . $table) or mysql_die();
}


function get_tables() {
	// returns an array with all tables in database
	global $mysql, $mysql_param;
	$res = [];
	$result = $mysql->query ('
		select table_name 
		from information_schema.tables 
		where table_schema="' . $mysql_param['database'] . '"
		') or mysql_die();
	while (($result) && ($row = $result->fetch_assoc())) {
		$res[] = $row['table_name'];
	}
	return $res;
}


// initialize
connect_mysql();
app_log ('');

?>