<?php


// parameter handling


// prerequisites
require_once ('functions/log.php');


function check_param ($name, $mask) {
	// extract parameter and check validity
	$params = array_change_key_case ($_GET);
	if (!isset ($params[$name])) {
		my_die ('missing parameter: ' . $name);
	}
	$value = $params[$name];
	if (preg_match ('/' . $mask . '/', $value)) {
		my_die ('illegal value for ' . $name);
	}
	app_log ($name . ': ' . $value);
	return $value;	
}


function optional_param ($name, $mask, $default) {
	// extract optional parameter and check validity, set default if parameter not supplied
	$params = array_change_key_case ($_GET);
	$value = isset ($params[$name]) ? $params[$name] : $default;
	if (preg_match ('/' . $mask . '/', $value)) {
		my_die ('illegal value for ' . $name);
	}
	app_log ($name . ': ' . $value);
	return $value;	
}


function optional_param_list ($name, $list, $default) {
	// extract optional parameter and check if it is valid from $list
	$params = array_change_key_case ($_GET);
	if (!isset ($params[$name])) {
		$value = $default;
	} else {
		foreach ($list as $option) {
			if (strtolower ($params[$name]) == $option) {
				$value = $option;
			}
		}
		if (!isset ($value)) {
			my_die ('illegal value for ' . $name);
		}
	}
	app_log ($name . ': ' . $value);
	return $value;
}



?>