<?php


// get data from database
require_once ('functions/mysql.php');


$gridlist = [
	'raw' => 'timestamp', 
	'5min' => 'from_unixtime(floor(unix_timestamp(timestamp)/300)*300)', 
	'hour' => 'from_unixtime(floor(unix_timestamp(timestamp)/3600)*3600)', 
	'day' => 'date(timestamp)',
	'month' => 'str_to_date (concat (year(timestamp), "-", month(timestamp), "-01"), "%Y-%m-%d")'
	];
	
	
function convert_local ($t) {
	// converts UTC time to local time as not all mysql installations can do this
	global $local_timezone;
	$date = new DateTime ($t . ' UTC');
	$date->setTimezone(new DateTimeZone ($local_timezone));
	$t = $date->format('Y-m-d H:i:s');
	unset ($date);
	return $t;
}	
	
	
function collect_data() {
	global $mysql, $table, $gridlist;
	check_table();
	$grid = optional_param_list ('grid', ['raw', '5min', 'hour', 'day', 'month'], 'hour');
	if ($grid == 'raw') {
		$res[] = ['timestamp', 'value', 'diff'];
		$select = 'timestamp as utc_grid_time, value, diff';
	} else {
		$res[] = ['utc_time', 'grid_time', 'min_time', 'max_time', 'min_val', 'avg_val', 'max_val', 'sum_val', 'sum_diff'];
		$select =
				$gridlist[$grid] . ' as utc_grid_time, ' .
				$gridlist[$grid] . ' as grid_time, min(timestamp) as min_time, max(timestamp) as max_time, 
				min(value) as min_val, round(avg(value),2) as avg_val, max(value) as max_val, sum(value) as sum_val, 
				sum(diff) as sum_diff
				';
	}
	$limit = optional_param ('limit', '[^0-9]', 24);
	$sort = array ('oldest' => 'asc', 'newest' => 'desc')[optional_param_list ('select', ['oldest', 'newest'], 'newest')];
	$result = $mysql->query ('
		select *
		from (
			select
				' . $select . '
			from (
				select timestamp, value, diff
				from ' . $table . '
				where 1
				order by timestamp asc) t1
			where 1
			group by utc_grid_time ' . $sort . '
			limit 0,' . $limit . ') t2
		where 1
		order by utc_grid_time asc;
	') or mysql_die();
	
	while (($result) && ($row = $result->fetch_assoc())) {
		if ($grid != 'raw') {
			foreach (['grid_time', 'min_time', 'max_time'] as $i) {
				$row[$i] = convert_local ($row[$i]);
			}
		}
		$res[] = $row;
	}
	return $res;	
}

?>